
#	.text

#  #define WRAP_OFFSET ('Z' - 'A' + 1)

WRAP_OFFSET:		equ	26
NEG_WRAP_OFFSET:	equ	-26
#  
#  int main()
#  {
main:
	addi $sp, $sp, -16	# Platz schaffen fuer 4xWord auf Stack
	sw   $ra, 0($sp)	# returnadresse retten
	sw   $s0, 4($sp)	# $s0 retten
	sw   $s1, 8($sp)	# $s1 retten
	sw   $s2, 12($sp)	# $s2 retten

#      char string[1024];

	addi $sp, $sp, -1024	# Platz schaffen fuer String
	move $s2, $sp		# Zeiger auf Puffer in $s2

#      int key;
#      printf("String:\n");

	li  $v0, 4		# print string
	la  $a0, string_str
	syscall

#      scanf("%s", &string[0]);

	li   $v0, 8		# read string
#	la   $a0, string_buf	# buf address
	move $a0, $s2
	li   $a1, 1024		# buf length
	syscall 

#      printf("Schluessel:\n");

	li  $v0, 4		# print string
	la  $a0, schluessel_str
	syscall

#      scanf("%d", &key);

	li  $v0, 5		# read integer
	syscall			# Eingabe in $v0
	move $s0, $v0		# Rueckgabe in $s0 retten


#      printf("Verschluesselt:\n");

	li  $v0, 4		# print string
	la  $a0, verschl_str
	syscall

#      printf("%s\n", encode(&string[0], key));

#	la   $a0, string_buf	# text
	move $a0, $s2
	move $a1, $s0		# key
	jal encode
	move $s1, $v0		# Rueckgabe in $s1 retten

	li   $v0, 4		# print string
	move $a0, $s1
	syscall

#      printf("Entschluesselt:\n");


	li  $v0, 4		# print string
	la  $a0, entschl_str
	syscall

#      printf("%s\n", decode(&string[0], key));

#	la  $a0, string_buf	# text
	move $a0, $s2
	move $a1, $s0		# key
	jal decode
	move $s1, $v0		# Rueckgabe in $s1 retten

	li   $v0, 4		# print string
	move $a0, $s1
	syscall

#      return EXIT_SUCCESS;
#  }
	move $v0, $zero

	addi $sp, $sp, 1024	# String Plath freigeben
	lw   $s2, 12($sp)	# $s2 wiederherstellen
	lw   $s1, 8($sp)	# $s1 wiederherstellen
	lw   $s0, 4($sp)	# $s0 wiederherstellen
	lw   $ra, 0($sp)	# returnadresse wiederherstellen
	addi $sp, $sp, 16	# Platz fuer 3xWord auf Stack freigeben
	j    $ra




#
#  char *encode (char * text, int key)
#  {
encode:
	addi $sp, $sp, -4	# Platz fuer 1xWord auf Stack schaffen
	sw   $ra, 0($sp)	# Register retten

#      int c;
#      char *rc = text;

	move $v0, $a0 		# Returnwert (Zeiger auf den String) in v0 laden

	li   $t7,'A'    	# Konstanten in Register laden
	li   $t6,'z'
	li   $t5,'Z'
	li   $t4,'a'

#      while ((c = *text) != 0)
#      {

	move $t0, $zero		# 32.bit Null in t0
encode_loop:
	lb   $t0, ($a0)		# unterste 8 Bit mit akt. Zeichen ueberladen
	beq  $t0, $zero, encode_end	# String zuende ? ja -> springen

#          if (c >= 'A' && c <= 'z')
#          {

	blt  $t0, $t7, encode_next	# liegt Zeichen im Bereich 'A' bis 'z'?
	bgt  $t0, $t6, encode_next	# falls nicht: -> springen


#              if (c <= 'Z')

	bgt  $t0, $t5, encode_klein	# ist es <= Z (-> Grossbuchstabe) ? falls nicht -> springen

#              { /* Grossbuchstabe */
#                  c += key;

	add  $t0, $t0, $a1		# Grossbuchstaben konvertieren (Ergebnis in t0)

#                  if (c > 'Z')

	ble  $t0, $t5, encode_next	# Wenn Ergebnis jetzt > 'Z' ist...

#                  {
#                      c -= WRAP_OFFSET;

	addi  $t0, $t0, NEG_WRAP_OFFSET	# ... -> offset zbziehen

#                  }
#              }

encode_klein:				
#              else if (c >= 'a')

	blt  $t0, $t4, encode_next	# falls es ein Kleinbuchstabe ist

#              { /* Kleinbuchstabe */
#                  c += key;

	add  $t0, $t0, $a1		#-> konvertieren

#                  if (c > 'z')

	ble  $t0, $t6, encode_next	# falls noetig ....
#                  {
#                      c -= WRAP_OFFSET;
#                  }

	addi  $t0, $t0, NEG_WRAP_OFFSET	# ... offset abziehen

#              }
#          }
#          *text = c;
#          ++text;

encode_next:
	sb    $t0, ($a0)		# konvertiertes Zeichen abspeichern
	addi  $a0, $a0, 1 		# auf naechstes Zeichen zeigen
	b     encode_loop		# zurueck zum Anfang

#      }

encode_end:
	lw   $ra, 0($sp)		# Fertig: returnadresse wiederherstellen
	addi $sp, $sp, 4		# Platz fuer 1xWord auf Stack freigeben
	j    $ra			# Zurueck zum Aufgrufer. Returnwert ist schon in v0

#      return rc;
#  }
#  
#  char *decode (char * text, int key)
#  {

decode:
	addi $sp, $sp, -4
	sw   $ra, 0($sp)


#      int c;
#      char *rc = text# 

	move $v0, $a0 

	li   $t7,'A'     # Konstanten in Register laden
	li   $t6,'z'
	li   $t5,'Z'
	li   $t4,'a'

#      while ((c = *text) != 0)
#      {

	move $t0, $zero
decode_loop:
	lb   $t0, ($a0)
	beq  $t0, $zero, decode_end

#          if (c >= 'A' && c <= 'z')
#          {

	blt  $t0, $t7, decode_next
	bgt  $t0, $t6, decode_next


#              if (c <= 'Z')

	bgt  $t0, $t5, decode_klein

#              { /* Grossbuchstabe */
#                  c -= key;

	sub  $t0, $t0, $a1

#                  if (c < 'A')

	bge  $t0, $t7, decode_next

#                  {
#                      c += WRAP_OFFSET;

	addi  $t0, $t0, WRAP_OFFSET

#                  }
#              }

decode_klein:
#              else if (c >= 'a')

	blt  $t0, $t4, decode_next

#              { /* Kleinbuchstabe */
#                  c -= key;

	sub  $t0, $t0, $a1

#                  if (c < 'a')

	bge  $t0, $t4, decode_next

#                  {
#                      c += WRAP_OFFSET;

	addi  $t0, $t0, WRAP_OFFSET

#                  }
#              }
#          }
#          *text = c;
#          ++text;

decode_next:
	sb    $t0, ($a0)
	addi  $a0, $a0, 1
	b     decode_loop

#      }

decode_end:
	lw   $ra, 0($sp)
	addi $sp, $sp, 4
	j    $ra

#      return rc;
#  }
#  
#	.data

string_str:		DB "\nString:\n"
schluessel_str:	DB "\nSchluessel:\n"
verschl_str:	DB "\nVerschluesselt:\n"
entschl_str:	DB "\nEntschluesselt:\n"

