    la $a0,msg1
    bal puts
    la $a0,msg2 
    bal puts
stop: b stop

;
; Hilfsroutine zur Stringausgabe:
;
UART_BASE:    equ 0xffffff00
UART_RX:      equ 0
UART_STAT:    equ 4
UART_TX:      equ 8
UART_CTRL:    equ 0xC
STAT_RXFULL:  equ 1
STAT_TXEMPTY: equ 2

puts:
    move  $t0,$a0
    la    $t1,UART_BASE
output_loop:
    lw    $a0,0($t0)             ; Zeichen holen
    beq   $a0,$zero,output_end   ; Null eingelesen?
waittx:
    lw    $t2,UART_STAT($t1)     ; while(!(uart->stat & STAT_TXEMPTY));
    andi  $t2,$t2,STAT_TXEMPTY
    beq   $t2,$zero,waittx
    sw    $a0,UART_TX($t1)       ; Ein Zeichen ausgeben
    addiu $t0,$t0,4              ; Zaehler inkrementieren
    b     output_loop            ; weiter
output_end:
    jr    $ra
;
; Daten:
;
msg1:     DC 0x48 
          DC 0x65
          DC 0x6C
          DC 0x6C
          DC 0x6F
          DC 0x20
          DC 0x57
          DC 0x6F
          DC 0x72
          DC 0x6C
          DC 0x64
          DC 0x0A
          DC 0x00
msg2:     DC 0x44
          DC 0x69
          DC 0x73
          DC 0x20
          DC 0x69
          DC 0x73
          DC 0x20
          DC 0x64
          DC 0x61
          DC 0x20
          DC 0x57
          DC 0x49
          DC 0x4D
          DC 0x50
          DC 0x21
          DC 0x21
          DC 0x0A
          DC 0x00 
