    la $a0,msg1
    bal puts
    la $a0,msg2 
    bal puts
    syscall 0


;
; Hilfsroutine zur Stringausgabe:
;
UART_BASE:    equ 0xffffff00
UART_RX:      equ 0
UART_STAT:    equ 4
UART_TX:      equ 8
UART_CTRL:    equ 0xC
STAT_RXFULL:  equ 1
STAT_TXEMPTY: equ 2

puts:
    move  $t0,$a0
    la    $t1,UART_BASE
output_loop:
    lb    $a0,0($t0)             ; Zeichen holen
    beq   $a0,$zero,output_end   ; Null eingelesen?
waittx:
    lw    $t2,UART_STAT($t1)     ; while(!(uart->stat & STAT_TXEMPTY));
    andi  $t2,$t2,STAT_TXEMPTY
    beq   $t2,$zero,waittx
    sw    $a0,UART_TX($t1)       ; Ein Zeichen ausgeben
    addiu $t0,$t0,1              ; Zaehler inkrementieren
    b     output_loop            ; weiter
output_end:
    jr    $ra
;
; Daten:
;
msg1:     DB "Hello World\n"
msg2:     DB "Dis is da WIMP!!\n"
